<?php

namespace Drupal\readonly_html_field\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Provides a field formatter of readonly html field.
 *
 * @FieldFormatter (
 *   id = "readonly_html_field_formatter",
 *   label = @Translation("Readonly Html field Formatter"),
 *   field_types = {"readonly_html_field"}
 * )
 */
class ReadonlyHtmlFieldFormatter extends FormatterBase {

  /**
   * {@inheritDoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $langcode = empty($langcode) ? \Drupal::languageManager()->getCurrentLanguage()->getId() : $langcode;
    $default_langcode = \Drupal::languageManager()->getDefaultLanguage()->getId();
    $default_readonly_html = $this->fieldDefinition->getSetting($default_langcode)['readonly_html']['value'];
    $readonly_html = $this->fieldDefinition->getSetting($langcode)['readonly_html']['value'];
    return [
      '#markup' => !empty($readonly_html) ? $readonly_html : $default_readonly_html,
    ];
  }

}
